using System;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
using System.Text;

namespace ConsoleApplicationBank
{
    class Bank
    {
        private const double frameCredit = -2000;
        private List<Account> bankList;
        private int numOfAccounts;
        private static int nextNumOfAccount = 1000;
        public Bank()
        {
            this.bankList = new List<Account>();
            this.numOfAccounts = 0;
        }
        public int OpenAccount(String ownerName)
        {
            Node<Account> prev = null;
            Node<Account> pos = this.bankList.GetFirst();

            while (pos != null)
            {
                if (ownerName.CompareTo(pos.GetInfo().GetName()) > 0)
                {
                    prev = pos;
                    pos = pos.GetNext();
                }
                else
                    break;

            }

            this.bankList.Insert(prev, new Account(ownerName, nextNumOfAccount));
            this.numOfAccounts++;
            nextNumOfAccount++;
            return nextNumOfAccount - 1;
        }
        public void Deposit(int accountNum, double amount)
        {
            Node<Account> pos = this.bankList.GetFirst();

            while (pos.GetInfo().GetNum() != accountNum)
                pos = pos.GetNext();
            pos.GetInfo().Deposit(amount);
        }
        public bool Withdrawal(int accountNum, double amount)
        {
            double balance;
            Node<Account> pos = this.bankList.GetFirst();

            while (pos.GetInfo().GetNum() != accountNum)
                pos = pos.GetNext();
            balance = pos.GetInfo().GetBalance();
            if (balance - amount < frameCredit)
            {
                return false;
            }
            else
            {
                pos.GetInfo().Withdrawal(amount);
                return true;
            }
        }
        public double GetBalance(int accountNum)
        {
            Node<Account> pos = this.bankList.GetFirst();

            while (pos.GetInfo().GetNum() != accountNum)
                pos = pos.GetNext();
            return pos.GetInfo().GetBalance();
        }
        public String GetOwnerName(int accountNum)
        {
            Node<Account> pos = this.bankList.GetFirst();

            while (pos.GetInfo().GetNum() != accountNum)
                pos = pos.GetNext();
            return pos.GetInfo().GetName();
        }
        public bool AccountExist(int accountNum)
        {
            Node<Account> pos = this.bankList.GetFirst();

            while (pos != null)
            {
                if (pos.GetInfo().GetNum() == accountNum)
                    return true;
                pos = pos.GetNext();
            }
            return false;
        }
        public List<int> GetAllAccountsNums()
        {
            List<int> accountsList = new List<int>();
            Node<int> p = null;
            Node<Account> pos = this.bankList.GetFirst();
            while (pos != null)
            {
                p = accountsList.Insert(p, pos.GetInfo().GetNum());
                pos = pos.GetNext();
                
            }
            return accountsList;
        }
        public int[] GetAllAccountsOf(String name)
        {
            List<int> accountsList = new List<int>();
            Node<int> p = null;
            Node<Account> pos = this.bankList.GetFirst();
            int counter = 0;
            
            while (pos != null)
            {
                if (name.CompareTo(pos.GetInfo().GetName()) == 0)
                {
                    p = accountsList.Insert(p, pos.GetInfo().GetNum());
                    counter++;
                }
                pos = pos.GetNext();
                
            }
            int[] allAccountsOf = new int[counter];
            p = accountsList.GetFirst();
            for (int i = 0; i < counter; i++)
            {
                allAccountsOf[i] = p.GetInfo();
                p = p.GetNext();
            }
            return allAccountsOf;
        }
        public override String ToString()
        {
            return this.bankList.ToString();
        }
    }
}
